-------------------------------------------
--- Author: Ketho (EU-Boulderfist)		---
--- Created: 2011.07.06					---
--- License: Public Domain				---
--- Version: 0.1 [2011.07.06]			---
-------------------------------------------
--- Curse			N/A
--- WoWInterface	N/A

-- events
local CRFM_Events = {
	"DISPLAY_SIZE_CHANGED",
	"UI_SCALE_CHANGED",
	"RAID_ROSTER_UPDATE",
	"UNIT_FLAGS",
	"PLAYER_FLAGS_CHANGED",
	"PLAYER_ENTERING_WORLD",
	"PARTY_LEADER_CHANGED",
	"RAID_TARGET_UPDATE",
	"PLAYER_TARGET_CHANGED",
	"PARTY_MEMBERS_CHANGED",
}

local CRFC_Events = {
	"RAID_ROSTER_UPDATE",
	"PARTY_MEMBERS_CHANGED",
	"UNIT_PET",
}

-- prehooks
local CRFM_Show = CompactRaidFrameManager.Show
local CRFC_Show = CompactRaidFrameContainer.Show

-- the conditional prehooks are already supposed to prevent
-- the raid frame from showing when it's initializing
function CompactRaidFrameManager:Show()
	if HideRaidFrameDB then
		CRFM_Show(self)
	end
end

function CompactRaidFrameContainer:Show()
	if HideRaidFrameDB then
		CRFC_Show(self)
	end
end

-- show
local function ShowRaidFrame()
	for _, v in ipairs(CRFM_Events) do
		CompactRaidFrameManager:RegisterEvent(v)
	end
	CompactRaidFrameManager:Show()
	for _, v in ipairs(CRFC_Events) do
		CompactRaidFrameContainer:RegisterEvent(v)
	end
	CompactRaidFrameContainer:Show()
end

-- hide
local function HideRaidFrame()
	CompactRaidFrameManager:UnregisterAllEvents()
	CompactRaidFrameManager:Hide()
	CompactRaidFrameContainer:UnregisterAllEvents()
	CompactRaidFrameContainer:Hide()
end

local delayAction

-- leaving combat
local function OnEvent(self, event)
	if delayAction then
		delayAction = false
		if HideRaidFrameDB then
			HideRaidFrameDB = false
			HideRaidFrame()
		else
			HideRaidFrameDB = true
			ShowRaidFrame()
		end
	end
end

local f = CreateFrame("Frame")
f:RegisterEvent("PLAYER_REGEN_ENABLED")
f:SetScript("OnEvent", OnEvent)

local function SlashCommand()
	if InCombatLockdown() then
		delayAction = true
		print("|cffFFFF00Raid Frame|r:", HideRaidFrameDB and "|cffFF2424Disabling|r after Combat" or "|cffADFF2FEnabling|r after Combat")
	else
		if HideRaidFrameDB then
			HideRaidFrameDB = false
			HideRaidFrame()
			print("|cffFFFF00Raid Frame|r: |cffFF2424Disabled|r")
		else
			HideRaidFrameDB = true
			ShowRaidFrame()
			print("|cffFFFF00Raid Frame|r: |cffADFF2FEnabled|r")
		end
	end
end

SLASH_HIDERAIDFRAME1 = "/hr"
SLASH_HIDERAIDFRAME2 = "/hrf"
SLASH_HIDERAIDFRAME3 = "/hideraid"
SLASH_HIDERAIDFRAME4 = "/hideraidframe"
SlashCmdList["HIDERAIDFRAME"] = SlashCommand